// Логический анализатор на ATMega-2560

volatile byte BHigh;
volatile byte BLow;
volatile byte B_aux;
volatile byte DATA[146];
volatile int CNT=0;

void setup()
{
  // инициализация
  // /KDA0...15 = A0...A15
  DDRF = B00000000;      // выводы порта F (А0...А7)  переключить на ввод
  DDRK = B00000000;      // выводы порта K (А8...А15) переключить на ввод
  DDRA = B00000000;      // выводы порта A переключить на ввод
  DDRC = B00000000;      // выводы порта C переключить на ввод  
  DDRE = B00000000;      // выводы порта E переключить на ввод
  pinMode(38, OUTPUT);  
  digitalWrite(38,LOW);

  PORTF = B00000000;     // выводы порта F (А0...А7)  певести в состояние Z
  PORTK = B00000000;     // выводы порта K (А8...А15) певести в состояние Z
  PORTA = B00000000;     // выводы порта A певести в состояние Z
  PORTC = B00000000;     // выводы порта C певести в состояние Z
  PORTE = B00000000;     // выводы порта E певести в состояние Z

  pinMode(13, INPUT);

  Serial.begin(9600,SERIAL_8N1);          // подключить порт UART

  attachInterrupt(2, SYNC_INT, FALLING);
  attachInterrupt(3, RPLY_INT, FALLING);

  digitalWrite(38,HIGH); // запуск инициализации ЦП
  delay(10);             // подождать, чтобы схамы запустились
  digitalWrite(38,LOW);  // вернуть линию в исходное состояние
}

void loop()
{
  if (digitalRead(13)==LOW)
  {
    int i = 0;
    for (i = 0; i < 145; i = i + 3)
    {  
      Serial.print(DATA[i]);
      Serial.print("-");
      Serial.print(DATA[i+1]);
      Serial.print("-");
      Serial.print(DATA[i+2]);
      Serial.print("  ");    
    }
    Serial.println(" *** ");
    CNT=0;
    delay(1000);
  }
} 



void SYNC_INT()
{
  BLow = ~PINF;              // считать инвертированные значения младшего байта
  BHigh = ~PINK;             // считать инвертированные значения старшего байта
  B_aux = ~PINA;
  DATA[CNT] = BHigh;         // вписать их в массив, сначала старший байт
  DATA[CNT+1] = BLow;        // потом младший
  DATA[CNT+2] = B_aux;  
  if (CNT<145) CNT = CNT + 3; // если счётчик байт не превысил 30, то увеличить на 2
}

void RPLY_INT()
{
  BLow = ~PINF;
  BHigh = ~PINK;
  B_aux = ~PINA;
  DATA[CNT] = BHigh;
  DATA[CNT+1] = BLow;
  DATA[CNT+2] = B_aux;
  if (CNT<145) CNT = CNT + 3;
}


